# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify Alma, CentOS, CentOS Stream and Rocky Linux as rhel
%if "%{__distinit}" == "a" || "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "cs" || "%{__distinit}" == "rl"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

#TODO: BR: perl(App::FatPacker) ≥ 0.10.0 for test suite when available

Name:		perl-Module-Pluggable
Epoch:		2
Version:	5.2
Release:	25.%{__distinit}%{__distvers}
Summary:	Automatically give your module the ability to have plug-ins
License:	GPL-1.0-or-later OR Artistic-1.0-Perl
URL:		https://metacpan.org/release/Module-Pluggable
Source0:	https://cpan.metacpan.org/modules/by-module/Module/Module-Pluggable-%{version}.tar.gz
BuildArch:	noarch
# Module Build
BuildRequires:	coreutils
BuildRequires:	findutils
BuildRequires:	make
BuildRequires:	perl-generators
BuildRequires:	perl-interpreter
BuildRequires:	perl(ExtUtils::MakeMaker)
# Module Runtime
BuildRequires:	perl(Carp)
%if 0%{?fedora} > 19 || 0%{?rhel} > 7
BuildRequires:	perl(deprecate)
%endif
BuildRequires:	perl(Exporter) >= 5.57
BuildRequires:	perl(File::Basename)
BuildRequires:	perl(File::Find)
BuildRequires:	perl(File::Spec::Functions)
BuildRequires:	perl(if)
BuildRequires:	perl(Module::Runtime) >= 0.012
BuildRequires:	perl(strict)
BuildRequires:	perl(vars)
BuildRequires:	perl(warnings)
# Test Suite
BuildRequires:	perl(base)
BuildRequires:	perl(Cwd)
BuildRequires:	perl(Data::Dumper)
BuildRequires:	perl(File::Copy)
BuildRequires:	perl(File::Path)
BuildRequires:	perl(File::Temp)
BuildRequires:	perl(FindBin)
BuildRequires:	perl(lib)
BuildRequires:	perl(Test::More)
# Dependencies
%if 0%{?fedora} < 38 && 0%{?rhel} < 10
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
%endif
Requires:	perl(Module::Runtime) >= 0.012
%if 0%{?fedora} > 19 || 0%{?rhel} > 7
Requires:	perl(deprecate)
%endif

%description
Provides a simple but, hopefully, extensible way of having 'plug-ins' for
your module.

%prep
%setup -q -n Module-Pluggable-%{version}

# Upstream distributes all files with exec bits set for reasons unknown
find . -type f -print | xargs chmod -c -x

%build
perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -delete
%{_fixperms} -c %{buildroot}

%check
make test

%files
%doc Changes README
%{perl_vendorlib}/Devel/
%{perl_vendorlib}/Module/
%{_mandir}/man3/Devel::InnerPackage.3*
%{_mandir}/man3/Module::Pluggable.3*
%{_mandir}/man3/Module::Pluggable::Object.3*

%changelog
* Fri Jul 14 2023 Paul Howarth <paul@city-fan.org> - 2:5.2-25
- Use SPDX-format license tag

* Mon Jun 29 2020 Paul Howarth <paul@city-fan.org> - 2:5.2-13
- Perl 5.32 rebuild

* Thu Jun  6 2019 Paul Howarth <paul@city-fan.org> - 2:5.2-11
- Perl 5.30 rebuild

* Fri Apr 27 2018 Paul Howarth <paul@city-fan.org> - 2:5.2-7
- BR: perl-generators unconditionally
- BR: perl-interpreter rather than perl
- Drop support for EOL distributions prior to F-13
  - Drop BuildRoot: and Group: tags
  - Drop explicit buildroot cleaning in %%install section
  - Drop explicit %%clean section

* Tue Sep  6 2016 Paul Howarth <paul@city-fan.org> - 2:5.2-3
- Fix FTBFS when perl is not in the minimal buildroot
- BR: perl-generators where available
- Simplify find commands using xargs and -delete

* Thu Aug  6 2015 Paul Howarth <paul@city-fan.org> - 2:5.2-1
- Update to 5.2
  - Use Module::Runtime if it's installed
  - Switch to using ExtUtils::MakeMaker
- Switch to ExtUtils::MakeMaker flow
- Classify buildreqs by usage
- Drop %%defattr, redundant since rpm 4.4

* Mon Jan  6 2014 Paul Howarth <paul@city-fan.org> - 2:5.1-1
- Update to 5.1
  - Fix the fact that we can't handle single letter package names
  - Gain support for @INC hooks and hence for App::FatPacker
  - Add in missing files left out of the MANIFEST due to stupidity

* Tue Jul 23 2013 Paul Howarth <paul@city-fan.org> - 2:4.8-3
- Bump epoch to 2 to override base package

* Sun Jul 21 2013 Paul Howarth <paul@city-fan.org> - 4.8-2
- Perl 5.18 rebuild

* Tue May 28 2013 Paul Howarth <paul@city-fan.org> - 4.8-1
- Update to 4.8
  - Fix some typos
  - Fix error in testing when Text::BibTex is installed

* Tue Feb 26 2013 Paul Howarth <paul@city-fan.org> - 4.7-1
- Update to 4.7
  - Fix more hash ordering bugs in tests by forcing sort of returned plugins

* Thu Jan 24 2013 Paul Howarth <paul@city-fan.org> - 4.6-1
- Update to 4.6
  - Add warning about future removal from core
- BR: perl(if)

* Tue Nov  6 2012 Paul Howarth <paul@city-fan.org> - 4.5-1
- Update to 4.5
  - Fix hash ordering bug in tests
  - Fix install dir
  - Documentation updates

* Tue Aug 21 2012 Paul Howarth <paul@city-fan.org> - 4.3-1
- Update to 4.3
  - Allow triggers on events, which gives a powerful way to modify behaviour
  - Put documentation in about behaviour under blib and test, allow searching
    outside blib under test
  - Made following symlinks the default behaviour, and added ability to turn
    that off
  - Fix installation path
  - Allow min_depth and max_depth
  - Set our @INC up to include and prefer our search_dirs if necessary
  - Switch to Module::Build
  - Fix a problem with installation directory
  - Fix calling the correct method when instantiating
  - Hopefully stop smoker failures
- Switch to Module::Build flow

* Fri Jun  8 2012 Paul Howarth <paul@city-fan.org> - 4.0-2
- BR: perl(base), perl(Data::Dumper), perl(Exporter) and
  perl(File::Spec::Functions)
- Don't need to remove empty directories from the buildroot
- Drop support for old distributions prior to FC-3:
  - Don't need to define %%{perl_vendorlib}
  - Use DESTDIR rather than PERL_INSTALL_ROOT

* Wed Jan  4 2012 Paul Howarth <paul@city-fan.org> - 4.0-1
- Update to 4.0
- BR: perl(Carp)

* Fri Jul  1 2011 Paul Howarth <paul@city-fan.org> - 3.90-4
- Rebuild for perl 5.14.1 in Rawhide
- Use %%{_fixperms} macro instead of our own %%{__chmod} incantation
- Nobody else likes macros for commands
- Fix dist tag for CentOS 6 and Scientific Linux

* Fri Jun 25 2010 Paul Howarth <paul@city-fan.org> - 3.90-3
- Rebuild for perl 5.12.1 in Rawhide

* Fri Jun  4 2010 Paul Howarth <paul@city-fan.org> - 3.90-2
- Fix dist tag for RHEL-6 Beta

* Tue Nov 24 2009 Paul Howarth <paul@city-fan.org> - 3.90-1
- Import from Fedora
- Update to 3.9

* Sat Dec 29 2007 Ralf Corsepius <rc040203@freenet.de> - 3.60-2
- Adjust License-tag
- Fix perms on sources
- BR: perl(Test::More) (BZ 419631)

* Tue Apr 17 2007 Steven Pritchard <steve@kspei.com> 3.60-1
- Update to 3.6

* Mon Jan 29 2007 Steven Pritchard <steve@kspei.com> 3.50-1
- Update to 3.5

* Sat Dec 09 2006 Steven Pritchard <steve@kspei.com> 3.40-1
- Update to 3.4
- Use fixperms macro instead of our own chmod incantation

* Sat Sep 16 2006 Steven Pritchard <steve@kspei.com> 3.10-2
- Fix find option order

* Mon Jul 17 2006 Steven Pritchard <steve@kspei.com> 3.10-1
- Update to 3.1 (using 3.10 for the package since 3.01 == 3.1 to rpm)
- BR Class::Inspector

* Thu Jun 08 2006 Steven Pritchard <steve@kspei.com> 3.01-1
- Update to 3.01
- Switch to Module::Build-based build

* Thu Mar 23 2006 Steven Pritchard <steve@kspei.com> 2.97-1
- Specfile autogenerated by cpanspec 1.62
- Clean up description a little
